--- app_voicemail.c	2005-10-31 18:20:30.000000000 -0800
+++ app_voicemail.c.new	2005-11-08 15:37:20.000000000 -0800
@@ -3832,7 +3832,7 @@
 
 static int close_mailbox(struct vm_state *vms, struct ast_vm_user *vmu)
 {
-	int x;
+	int x, nummsg;
 	int res = 0;
 
 	if (vms->lastmsg <= -1)
@@ -3865,12 +3865,14 @@
 			} 
 		} 
 	} 
-	for (x = vms->curmsg + 1; x <= vmu->maxmsg; x++) { 
-		make_file(vms->fn, sizeof(vms->fn), vms->curdir, x); 
-		if (!EXISTS(vms->curdir, x, vms->fn, NULL)) 
-			break;
-		DELETE(vms->curdir, x, vms->fn);
-	} 
+
+	/* Delete ALL remaining messages */
+	nummsg = x;
+	for (x = vms->curmsg + 1; x <= nummsg; x++) {
+		make_file(vms->fn, sizeof(vms->fn), vms->curdir, x);
+		if (EXISTS(vms->curdir, x, vms->fn, NULL))
+			DELETE(vms->curdir, x, vms->fn);
+	}
 	ast_unlock_path(vms->curdir);
 
 done:
